regina::NGluingPerms Class Reference
Census of Triangulations

Represents a specific set of gluing permutations to complement a particular pairwise matching of tetrahedron faces. More...

`#include <census/ngluingperms.h>`

Inheritance diagram for regina::NGluingPerms:

## Public Member Functions

| NGluingPerms (const NGluingPerms &cloneMe)
| Creates a new set of gluing permutations that is a clone of the given permutation set. More...
| NGluingPerms (std::istream &in)
| Reads a new set of gluing permutations from the given input stream. More...
unsigned | getNumberOfTetrahedra () const
| Returns the total number of tetrahedra under consideration. More...
const NFacePairing * | getFacePairing () const
| Returns the specific pairing of tetrahedron faces that this set of gluing permutations complements. More...
Public Member Functions inherited from regina::NGenericGluingPerms< 3 >
| NGenericGluingPerms (const NGenericGluingPerms< dim > &cloneMe)
| Creates a new set of gluing permutations that is a clone of the given permutation set. More...
| NGenericGluingPerms (std::istream &in)
| Reads a new set of gluing permutations from the given input stream. More...
virtual | ~NGenericGluingPerms ()
| Deallocates any memory used by this structure. More...
bool | inputError () const
| Was an error found during construction from an input stream? More...
unsigned | size () const
| Returns the total number of simplices under consideration. More...
const FacetPairing * | getFacetPairing () const
| Returns the specific pairing of simplex facets that this set of gluing permutations complements. More...
Perm | gluingPerm (const NFacetSpec< dim > &source) const
| Returns the gluing permutation associated with the given simplex facet. More...
Perm | gluingPerm (unsigned simp, unsigned facet) const
| Returns the gluing permutation associated with the given simplex facet. More...
Triangulation * | triangulate () const
| Returns a newly created triangulation as modelled by this set of gluing permutations and the associated simplex facet pairing. More...
virtual void | dumpData (std::ostream &out) const
| Dumps all internal data in a plain text format to the given output stream. More...

## Protected Member Functions

| NGluingPerms (const NFacePairing *pairing)
| Creates a new permutation set. More...
Protected Member Functions inherited from regina::NGenericGluingPerms< 3 >
| NGenericGluingPerms (const FacetPairing *pairing)
| Creates a new permutation set. More...
int & | permIndex (const NFacetSpec< dim > &source)
| Returns the index into array Perm::Sn_1 describing how the the given facet is joined to its partner. More...
int & | permIndex (unsigned simp, unsigned facet)
| Returns the index into array Perm::Sn_1 describing how the the given facet is joined to its partner. More...
const int & | permIndex (const NFacetSpec< dim > &source) const
| Returns the index into array Perm::Sn_1 describing how the the given facet is joined to its partner. More...
const int & | permIndex (unsigned simp, unsigned facet) const
| Returns the index into array Perm::Sn_1 describing how the the given facet is joined to its partner. More...
int | gluingToIndex (const NFacetSpec< dim > &source, const Perm &gluing) const
| Returns the index into array Perm::Sn_1 corresponding to the given gluing permutation from the given facet to its partner. More...
int | gluingToIndex (unsigned simp, unsigned facet, const Perm &gluing) const
| Returns the index into array Perm::Sn_1 corresponding to the given gluing permutation from the given facet to its partner. More...
Perm | indexToGluing (const NFacetSpec< dim > &source, int index) const
| Returns the gluing permutation from the given facet to its partner that corresponds to the given index into array Perm::Sn_1. More...
Perm | indexToGluing (unsigned simp, unsigned facet, int index) const
| Returns the gluing permutation from the given facet to its partner that corresponds to the given index into array Perm::Sn_1. More...

## Additional Inherited Members

Public Types inherited from regina::NGenericGluingPerms< 3 >
typedef DimTraits< dim > ::FacetPairing | FacetPairing
typedef DimTraits< dim >::Perm | Perm
typedef DimTraits< dim >::Simplex | Simplex
typedef DimTraits< dim > ::Triangulation | Triangulation
Protected Attributes inherited from regina::NGenericGluingPerms< 3 >
const FacetPairing * | pairing_
| The facet pairing that this permutation set complements. More...
int * | permIndices_
| The index into array Perm::Sn_1 describing how each simplex facet is glued to its partner. More...
bool | inputError_
| Has an error occurred during construction from an input stream? More...

## Detailed Description

Represents a specific set of gluing permutations to complement a particular pairwise matching of tetrahedron faces.

Given a pairwise matching of faces (as described by class NFacePairing), each face that is matched with some other face will have an associated permutation of four elements (as described by class NPerm4).

If a face is matched with some other face, the two associated permutations in this set will be inverses. If a face is left deliberately unmatched, it will have no associated permutation in this set.

Such a set of permutations models part of the structure of a triangulation, in which each tetrahedron face that is glued to another face has a corresponding gluing permutation (and the matched face has the inverse gluing permutation).

Python:
  Not present.

## Constructor & Destructor Documentation

regina::NGluingPerms::NGluingPerms | ( | const NGluingPerms & | cloneMe | ) |

inline

Creates a new set of gluing permutations that is a clone of the given permutation set.

Parameters

  cloneMe | the gluing permutations to clone.

regina::NGluingPerms::NGluingPerms | ( | std::istream & | in | ) |

inline

Reads a new set of gluing permutations from the given input stream.

This routine reads data in the format written by dumpData().

If the data found in the input stream is invalid or incorrectly formatted, the routine inputError() will return `true` but the contents of this object will be otherwise undefined.

Warning
  The data format is liable to change between Regina releases. Data in this format should be used on a short-term temporary basis only.

Parameters

  in | the input stream from which to read.

regina::NGluingPerms::NGluingPerms | ( | const NFacePairing * | pairing | ) |

inline protected

Creates a new permutation set.

All internal arrays will be allocated but not initialised.

Precondition
  The given face pairing is connected, i.e., it is possible to reach any tetrahedron from any other tetrahedron via a series of matched face pairs.
  The given face pairing is in canonical form as described by NFacePairing::isCanonical(). Note that all face pairings constructed by NFacePairing::findAllPairings() are of this form.

Parameters

  pairing | the specific pairing of tetrahedron faces that this permutation set will complement.

## Member Function Documentation

const NFacePairing * regina::NGluingPerms::getFacePairing | ( |  | ) | const

inline

Returns the specific pairing of tetrahedron faces that this set of gluing permutations complements.

Deprecated:
  This routine has been renamed to getFacetPairing(). This old name has been kept for backward compatibility, but will be removed in some future version of Regina.

Returns
  the corresponding tetrahedron face pairing.

unsigned regina::NGluingPerms::getNumberOfTetrahedra | ( |  | ) | const

inline

Returns the total number of tetrahedra under consideration.

Deprecated:
  This routine has been renamed to size(). This old name has been kept for backward compatibility, but will be removed in some future version of Regina.

Returns
  the number of tetrahedra under consideration.

The documentation for this class was generated from the following file:

- census/ngluingperms.h

Copyright © 1999-2013, The Regina development team
This software is released under the GNU General Public License, with some additional permissions; see the source code for details.
For further information, or to submit a bug or other problem, please contact Ben Burton (bab@debian.org).